

' EJERCICIO BASADO EN OTRO DE DAMIAN CASTROVIEJO TITULADO
' --- How to use a recursive function to read a directory structure and save it to XML ---

' Espacio de nombres con las clases DirectoryInfo y FileInfo
Imports System.IO

Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Código generado por el Diseñador de Windows Forms "

    Public Sub New()
        MyBase.New()

        'El Diseñador de Windows Forms requiere esta llamada.
        InitializeComponent()

        'Agregar cualquier inicialización después de la llamada a InitializeComponent()

    End Sub

    'Form reemplaza a Dispose para limpiar la lista de componentes.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub

    'Requerido por el Diseñador de Windows Forms
    Private components As System.ComponentModel.IContainer

    'NOTA: el Diseñador de Windows Forms requiere el siguiente procedimiento
    'Puede modificarse utilizando el Diseñador de Windows Forms. 
    'No lo modifique con el editor de código.
    Friend WithEvents folderDlg As System.Windows.Forms.FolderBrowserDialog
    Friend WithEvents BtAbrir As System.Windows.Forms.Button
    Friend WithEvents BtSalir As System.Windows.Forms.Button
    Friend WithEvents BtListBox As System.Windows.Forms.Button
    Friend WithEvents listBox As System.Windows.Forms.ListBox
    Friend WithEvents BtDesc1 As System.Windows.Forms.Button
    Friend WithEvents btExt1 As System.Windows.Forms.Button
    Friend WithEvents BtAsc1 As System.Windows.Forms.Button
    Friend WithEvents lblList As Label
    Friend WithEvents txtExt1 As System.Windows.Forms.TextBox
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim resources As System.ComponentModel.ComponentResourceManager = New System.ComponentModel.ComponentResourceManager(GetType(Form1))
        Me.folderDlg = New System.Windows.Forms.FolderBrowserDialog()
        Me.BtAbrir = New System.Windows.Forms.Button()
        Me.BtSalir = New System.Windows.Forms.Button()
        Me.BtListBox = New System.Windows.Forms.Button()
        Me.BtDesc1 = New System.Windows.Forms.Button()
        Me.btExt1 = New System.Windows.Forms.Button()
        Me.BtAsc1 = New System.Windows.Forms.Button()
        Me.txtExt1 = New System.Windows.Forms.TextBox()
        Me.listBox = New System.Windows.Forms.ListBox()
        Me.lblList = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'BtAbrir
        '
        resources.ApplyResources(Me.BtAbrir, "BtAbrir")
        Me.BtAbrir.Name = "BtAbrir"
        '
        'BtSalir
        '
        resources.ApplyResources(Me.BtSalir, "BtSalir")
        Me.BtSalir.DialogResult = System.Windows.Forms.DialogResult.Cancel
        Me.BtSalir.Name = "BtSalir"
        '
        'BtListBox
        '
        resources.ApplyResources(Me.BtListBox, "BtListBox")
        Me.BtListBox.Name = "BtListBox"
        '
        'BtDesc1
        '
        resources.ApplyResources(Me.BtDesc1, "BtDesc1")
        Me.BtDesc1.Name = "BtDesc1"
        '
        'btExt1
        '
        resources.ApplyResources(Me.btExt1, "btExt1")
        Me.btExt1.Name = "btExt1"
        '
        'BtAsc1
        '
        resources.ApplyResources(Me.BtAsc1, "BtAsc1")
        Me.BtAsc1.Name = "BtAsc1"
        '
        'txtExt1
        '
        resources.ApplyResources(Me.txtExt1, "txtExt1")
        Me.txtExt1.Name = "txtExt1"
        '
        'listBox
        '
        resources.ApplyResources(Me.listBox, "listBox")
        Me.listBox.BackColor = System.Drawing.Color.White
        Me.listBox.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle
        Me.listBox.Name = "listBox"
        Me.listBox.TabStop = False
        '
        'lblList
        '
        resources.ApplyResources(Me.lblList, "lblList")
        Me.lblList.Name = "lblList"
        '
        'Form1
        '
        resources.ApplyResources(Me, "$this")
        Me.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Dpi
        Me.CancelButton = Me.BtSalir
        Me.Controls.Add(Me.lblList)
        Me.Controls.Add(Me.BtDesc1)
        Me.Controls.Add(Me.BtListBox)
        Me.Controls.Add(Me.listBox)
        Me.Controls.Add(Me.BtSalir)
        Me.Controls.Add(Me.BtAbrir)
        Me.Controls.Add(Me.BtAsc1)
        Me.Controls.Add(Me.btExt1)
        Me.Controls.Add(Me.txtExt1)
        Me.FormBorderStyle = System.Windows.Forms.FormBorderStyle.Fixed3D
        Me.MaximizeBox = False
        Me.MinimizeBox = False
        Me.Name = "Form1"
        Me.ResumeLayout(False)
        Me.PerformLayout()

    End Sub

#End Region

    ' Variables visibles por toda la clase
    '
    ' Ruta al directorio cuyos archivos van a ser listados
    Private strPath As String
    ' Matriz con las carpetas del directorio seleccionado
    Private strCarpeta() As String
    ' Enteros para contar archivos
    Private n, i, j As Integer
    ' Variable a para saber si se ha seleccionado algún directorio o todavía no
    ' Variable b para ordenar los archivos de forma ascendente o descendente
    Private a, b As Boolean
    ' Enteros para contar el tiempo transcurrido en llevar a cabo un procedimiento
    Private inicio, final As Integer

    ' Al cargar el formulario: tamaño y posición (pos. horizontal = en el medio) (alto = alto de la pantalla - 140 px)
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Me.Left = (Screen.PrimaryScreen.WorkingArea.Width - Me.Width) \ 2
        Me.Top = 70
        Me.Height = (Screen.PrimaryScreen.WorkingArea.Height) - 140
        Me.Width = 535
    End Sub

    Private Sub BtAbrir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtAbrir.Click
        AbrirCarpeta() ' procedimiento que se encarga de elegir el directorio
    End Sub

    ' PROCEDIMIENTO QUE SE ENCARGA DE ELEGIR EL DIRECTORIO
    Private Sub AbrirCarpeta()
        Try
            ' Cuadro de diálogo de selección de carpeta (FolderBrowserDialog)
            If folderDlg.ShowDialog = Windows.Forms.DialogResult.OK Then
                ' strPath contiene la ruta al directorio elegido y strCarpeta una matriz con sus archivos
                strPath = folderDlg.SelectedPath
            End If
            strCarpeta = System.IO.Directory.GetFiles(strPath)
            '
            Me.Text = "Dir2Files"
            ' Mostrar la ruta completa al directorio 
            lblList.Text = "Directorio seleccionado: " + strPath + ""
            ' Mostrar sólo el nombre del directorio, sin la ruta
            'lblList.Text = "" + strPath.Substring(strPath.LastIndexOf("\") + 1) + ""
            '
            ' Para saber que ya se ha seleccionado un directorio
            a = True
        Catch pollo As Exception
            Return
        End Try
    End Sub

    ' PROCEDIMIENTO QUE RELLENA EL CONTROL LISTBOX CON LOS ARCHIVOS
    ' Y MUESTRA EL TIEMPO QUE TARDA EN LLEVARSE A CABO ESE PROCESO
    Private Sub BtListBox_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtListBox.Click
        Try
            '
            If a Then
                ' Environment.TickCount devuelve el nº de milisegundos desde que se ha iniciado Windows
                ' Calculando la propiedad TickCount al comienzo y al final del procedimiento vemos su duración
                ' Es una forma poco elaborada de comparar el rendimiento de procedimientos diferentes
                inicio = System.Environment.TickCount
                '
                ' Rellenar el control ListBox llamando a la funcion recursiva ListarArchivos1
                ' a la que se le pasan 2 parámetros String:
                '- nombre del directorio actual, cambia en cada pasada recursiva
                '- ruta completa al directorio actual
                ' Al empezar la serie, ambas rutas coinciden (nombre y ruta del directorio actual)
                listBox.Items.Clear()
                ListarArchivos1(strPath + "\", strPath + "\")
                '
                j = listBox.Items.Count
                Me.Text = "Archivos: " + CStr(j)
                '
                final = System.Environment.TickCount
                ' Información del tiempo empleado en rellenar el control ListBox
                MsgBox("Tiempo utilizado en el proceso: " + CStr(((final - inicio) / 1000)) + " segundos.")
            End If
            '
        Catch pollo As Exception
            If Not pollo.GetType.ToString = "System.UnauthorizedAccessException" Then
                MsgBox("Se ha producido una excepción:" + vbCrLf + pollo.GetType.ToString + ".", MsgBoxStyle.Information)
            End If
        End Try
    End Sub

    ' FUNCION RECURSIVA QUE RELLENA EL CONTROL LISTBOX SÓLO CON NOMBRES DE ARCHIVOS
    ' A LA FUNCIÓN SE LE PASAN 2 PARÁMETROS:
    '- NOMBRE DEL DIRECTORIO ACTUAL, CAMBIA EN CADA PASADA RECURSIVA
    '- RUTA COMPLETA AL DIRECTORIO ACTUAL
    Private Function ListarArchivos1(ByVal s As String, ByVal strPath As String) As Object
        Try
            '
            Me.Text = "Procesando..."
            '
            ' Variables para contener información sobre archivos y carpetas
            Dim d As DirectoryInfo
            Dim ofs As New DirectoryInfo(strPath + "\")
            Dim oFile As FileInfo
            '
            ' Bucle For Each para las carpetas: obtener todas las carpetas contenidas en el directorio seleccionado
            For Each d In ofs.GetDirectories
                ' Llamada recursiva (ListarArchivos1 es llamada desde dentro de ListarArchivos1)
                ' Porque cada carpeta puede tener a su vez subcarpetas que también han de ser analizadas
                ListarArchivos1(d.Name, strPath + "\" + d.Name)
            Next
            '
            ' Bucle For Each para los archivos: obtener todos los archivos existentes en cada una de las carpetas y añadirlos al ListBox
            ' Este bucle no necesita llamadas recursivas porque un archivo no tiene subarchivos que recorrer
            For Each oFile In ofs.GetFiles
                ' Distintas formas de mostrar la lista de archivos en el control ListBox
                'listBox.Items.Add((listBox.Items.Count + 1) + ". " + oFile.Name)
                'listBox.Items.Add(oFile.Name + " [" + (listBox.Items.Count + 1) + "]")
                listBox.Items.Add(oFile.Name)
            Next
            '
        Catch pollo As Exception
            If Not pollo.GetType.ToString = "System.UnauthorizedAccessException" Then
                MsgBox("Se ha producido una excepción:" + vbCrLf + pollo.GetType.ToString + ".", MsgBoxStyle.Information)
            End If
        End Try
    End Function

    ' ORDENAR EL CONTROL LISTBOX DE FORMA DESCENDENTE
    Private Sub BtDesc1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtDesc1.Click
        If a Then
            b = False
            Call OrdenarLista1(listBox)
        End If
    End Sub

    ' ORDENAR EL CONTROL LISTBOX DE FORMA ASCENDENTE
    Private Sub BtAsc1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtAsc1.Click
        If a Then
            b = True
            Call OrdenarLista1(listBox)
        End If
    End Sub

    ' ORDENAR EL CONTROL LISTVIEW USANDO UN ARRAYLIST
    Private Sub OrdenarLista1(ByRef listBox As ListBox)
        Try
            '
            ' El proceso de ordenar un ListBox es complejo por lo que se recurre a este "truco":
            ' - utilizamos un ArrayList como almacén temporal de la lista de archivos del ListBox
            ' - volcamos el contenido del ListBox al ArrayList
            ' - vaciamos el ListBox
            ' - ordenamos el Arraylist
            ' - lo volcamos al ListBox con los elementos ordenados
            Dim matriz As New ArrayList
            Dim indice As Integer
            '
            inicio = System.Environment.TickCount
            '
            Me.Text = "Procesando..."
            '
            For indice = 0 To listBox.Items.Count - 1
                'matriz.Add(CStr(listBox.Items(indice)))
                matriz.Add(listBox.Items(indice))
            Next
            matriz.Sort()
            listBox.Items.Clear()
            '
            If b = True Then
                ' ordenar de manera ascendente
                For indice = matriz.Count - 1 To 0 Step -1
                    listBox.Items.Add(matriz(indice))
                Next
            Else
                ' ordenar de manera descendente
                For indice = 0 To matriz.Count - 1
                    listBox.Items.Add(matriz(indice))
                Next
            End If
            '
            Me.Text = "Dir2Files"
            '
            final = System.Environment.TickCount
            MsgBox("Tiempo utilizado en el proceso: " + CStr(((final - inicio) / 1000)) + " segundos.")
            '
        Catch pollo As Exception
            If Not pollo.GetType.ToString = "System.UnauthorizedAccessException" Then
                MsgBox("Se ha producido una excepción:" + vbCrLf + pollo.GetType.ToString + ".")
            End If
        End Try
    End Sub

    ' LISTAR LOS ARCHIVOS CON UNA EXTENSIÓN DETERMINADA
    Private Sub BtExtension_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btExt1.Click
        Try
            '
            ' Si el cuadro de texto txtExt1 no está vacío
            If txtExt1.Text.Length > 0 Then
                '
                inicio = System.Environment.TickCount
                '
                ' rellenar el ListBox (para buscar siempre en la lista completa y no
                ' en la de la extensión que se haya usado previamente)
                listBox.Items.Clear()
                ListarArchivos1(strPath + "\", strPath + "\")
                j = listBox.Items.Count
                '
                ' Utilizamos un ArrayList como almacén temporal de la lista de archivos del ListBox
                ' - pasamos al ArrayList los elementos del ListBox cuyo nombre termina en la extensión buscada
                ' - vaciamos el ListBox
                ' - volcamos el ArrayList al ListBox con los elementos encontrados
                Dim matriz As New ArrayList
                Dim indice As Integer
                '
                For indice = 0 To listBox.Items.Count - 1
                    If CStr(listBox.Items(indice)).EndsWith("." + txtExt1.Text, StringComparison.CurrentCultureIgnoreCase) Then
                        matriz.Add(CStr(listBox.Items(indice)))
                    End If
                Next
                listBox.Items.Clear()
                '
                For indice = 0 To matriz.Count - 1
                    listBox.Items.Add(matriz(indice))
                Next
                '
                ' Información en la barra de título
                j = listBox.Items.Count
                Me.Text = "Archivos ." + txtExt1.Text + ": " + CStr(j)
                '
                final = System.Environment.TickCount
                MsgBox("Tiempo utilizado en el proceso: " + CStr(((final - inicio) / 1000)) + " segundos.")
                '
            Else
                If a = True Then
                    MsgBox("Falta la extensión para la búsqueda", MsgBoxStyle.Information)
                End If
            End If
            '
        Catch pollo As Exception
            If Not pollo.GetType.ToString = "System.UnauthorizedAccessException" Then
                MsgBox("Se ha producido una excepción:" + vbCrLf + pollo.GetType.ToString + ".")
            End If
        End Try
    End Sub

    Private Sub BtSalir_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles BtSalir.Click
        Me.Close()
    End Sub

End Class
